package com.example.main.android;

import java.util.Arrays;
import java.util.regex.Pattern;

import com.example.core.logic.BSort;
import com.example.sortingapp.R;

import android.os.Bundle;
import android.app.Activity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.RadioGroup;

public class MainActivity extends Activity {

	private EditText text;
	private String element, woSpace, outputFilter;
	private String []part;
	private BSort bs = new BSort();
	private Integer []inputInt;
	private RadioGroup group;
	private RadioButton rb;	
	private Button sort, clear;
	private CheckBox cb;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		buttonListener();
	}

	//http://www.mkyong.com/android/android-radio-buttons-example/
	public void buttonListener(){

		group =(RadioGroup) findViewById(R.id.radioGroup1);
		sort = (Button) findViewById(R.id.button1);
		clear = (Button)findViewById(R.id.button2);
		cb = (CheckBox)findViewById(R.id.checkbox_descending);


		cb.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				bs.setDescending(cb.isChecked());
			}
		});


		sort.setOnClickListener(new OnClickListener(){
			@Override
			public void onClick(View arg0) {
			
				text = (EditText) findViewById(R.id.inputValue);
				String inputValue = (text.getText().toString());
				element =inputValue;
				woSpace = element.replaceAll(" ", "");
				part = woSpace.split(Pattern.quote(","));
				inputInt = new Integer[part.length];

				int sId = group.getCheckedRadioButtonId();
				//System.out.println(sId);
				rb = (RadioButton) findViewById(sId);
				switch(sId){
				//replace all with nothing except a(A) to z(Z), 0-9
				case R.id.radio0:
					outputFilter= Arrays.toString(bs.bsort(part)).replaceAll("[^a-zA-Z0-9, ]", "");

					break;
				//split a single word into characters (String), replace all with nothing except a(A) to z(Z), 0-9
				case R.id.radio1:
					part = woSpace.split(Pattern.quote(""));
					outputFilter=Arrays.toString(bs.bsort(part)).replaceAll("[^a-zA-Z0-9]", "");
					break;
				//replace all with nothing except 0-9
				case R.id.radio2:
					try {
						for(int i =0; i< part.length; i++)
							inputInt[i] =Integer.parseInt(part[i]);

						outputFilter=Arrays.toString(bs.bsort(inputInt)).replaceAll("[^0-9, ]", "");

					} catch (NumberFormatException e) {
						// TODO: handle exception

						outputFilter="integer input expected";
					}
					break;
				}

				text.setText(outputFilter);

			}
		});

		clear.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				try {
					text.getText().clear();
				} catch (NullPointerException e) {
					// TODO: handle exception
				}
					

			}
		});


	}

}
